/* TCPdaytime_t.c - TCPdaytime_t, main 
    Cesar Kallas
    02099224
*/

#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <pthread.h>

int	errno;

void *TCPdaytime(void *threadid);
int	errexit(const char *format, ...);
int	connectTCP(const char *host, const char *service);

#define	LINELEN		128
#define NUM_THREADS     10000

pthread_t t_tcpdaytime[NUM_THREADS];
int	respostas=0;
char	*host = "localhost";	/* host to use if none supplied	*/
char	*service = "daytime";	/* default service port		*/


/*------------------------------------------------------------------------
 * main - TCP client for DAYTIME service
 *------------------------------------------------------------------------
 */
int
main(int argc, char *argv[])
{
	int	i, ts, rc, status;
	switch (argc) {
	case 1:
		host = "localhost";
		break;
	case 3:
		service = argv[2];
		/* FALL THROUGH */
	case 2:
		host = argv[1];
		break;
	default:
		fprintf(stderr, "usage: TCPdaytime [host [port]]\n");
		exit(1);
	}
	
	printf("\numero threads: %d", NUM_THREADS);

	for (i=0;i<NUM_THREADS;i++) {
		
	    // tenta criar um thread consumidor
	    ts = pthread_create(&t_tcpdaytime[i], NULL, TCPdaytime, (void *)i+1);
	    if (ts) {
	    printf("ERRO: impossivel criar um thread \n");
	    exit(-1);	
	    }
	}
	for(i=0; i<NUM_THREADS; i++){
	    rc = pthread_join(t_tcpdaytime[i], (void **)&status);
	    if(rc){
	    printf("ERROR; return code from pthread_join() is%d\n", rc);
	    exit(-1);
	    }
	}
	printf("Terminando o thread main(), respotas: %d\n", respostas);
	pthread_exit(NULL);
	
	exit(0);
}

/*------------------------------------------------------------------------
 * TCPdaytime - invoke Daytime on specified host and print results
 *------------------------------------------------------------------------
 */
void *TCPdaytime(void *threadid)
{
	char	buf[LINELEN+1];		/* buffer for one line of text	*/
	int	s, n;			/* socket, read count		*/
	
	s = connectTCP(host, service);
	while( (n = read(s, buf, LINELEN)) > 0) {
	    buf[n] = '\0';		/* ensure null-terminated	*/
//	    (void) fputs( buf, stdout );
	    printf("%sthreadid: %d\trespostas: %d\n", buf, threadid, ++respostas);
	    fflush(stdout);
	}
	close(s);
}
